Scriptname AR_QuickLoot_Ref_AliasScript extends ReferenceAlias  

Actor Property PlayerRef Auto

GlobalVariable Property AR_WeaponDrawn Auto
GlobalVariable Property AR_ForceThirdPerson Auto
GlobalVariable Property AR_AnimationTrigger Auto

FormList Property QL_Interact_CustomContainers Auto

Race Property DLC1VampireBeastRace Auto
Race Property WerewolfBeastRace Auto

Event OnInit()
	Utility.Wait(3)
	RegisterForMenu("LootMenu")
EndEvent

Event OnPlayerLoadGame()
	Utility.Wait(3)
	RegisterForMenu("LootMenu")
EndEvent

Event OnMenuOpen(String menuName)
	If menuName == "LootMenu"
		If !PlayerRef.GetSitState() && !PlayerRef.IsSwimming() && !PlayerRef.IsOnMount() && !PlayerRef.GetAnimationVariableBool("isStaggering") && PlayerRef.GetRace() != DLC1VampireBeastRace  && PlayerRef.GetRace() != WerewolfBeastRace
			GoToState("QuickLootingST")
		EndIf
	EndIf
EndEvent

Event OnMenuClose(String menuName)
	If menuName == "LootMenu"
		GoToState("")
	EndIf
EndEvent

State QuickLootingST
	Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
		If (!AR_ForceThirdPerson.GetValue() && Game.GetCameraState() == 0) || !UI.IsMenuOpen("LootMenu") || (akSourceContainer != Game.GetCurrentCrosshairRef() && !QL_Interact_CustomContainers.HasForm(Game.GetCurrentCrosshairRef().GetBaseObject())) || (PlayerRef.IsWeaponDrawn() && !AR_WeaponDrawn.GetValue())
			; Doesn't play animation if force third person is disabled, QuickLoot is not opened anymore, if the source container of the item is different than the one player is currently looking at
			Return
		EndIf
		If akSourceContainer.HasKeywordString("ActorTypeNPC") || akSourceContainer.HasKeywordString("ActorTypeDwarven") || akSourceContainer.HasKeywordString("ActorTypeCreature") || akSourceContainer.HasKeywordString("ActorTypeAnimal") || akSourceContainer.GetBaseObject() as Container 
			; Support for Immersive Hunting Animations
			If Game.IsPluginInstalled("ImmersiveHunting.esp")
				If akSourceContainer.HasKeywordString("ActorTypeAnimal") || akSourceContainer.HasKeywordString("LootingSmallAnimal") || akSourceContainer.HasKeywordString("LootingLargeAnimal") 
					Return
				EndIf
			EndIf
			Bool isFirstPerson
			If Game.GetCameraState() == 0
				Game.ForceThirdPerson()
				isFirstPerson = True
			EndIf
			If PlayerRef.IsWeaponDrawn()
				AR_AnimationTrigger.SetValue(1)
				Debug.SendAnimationEvent(PlayerRef, "IdleCombatStretchingStart")
				AR_AnimationTrigger.SetValue(0)
			Else
				Debug.SendAnimationEvent(PlayerRef, "IdlePickup_Ground")
			EndIf
			If isFirstPerson && AR_ForceThirdPerson.GetValue() == 2
				Utility.Wait(2.5)
				Debug.SendAnimationEvent(PlayerRef, "IdleStop")
				Game.ForceFirstPerson()
			EndIf
			GoToState("")
		EndIf	
	EndEvent
EndState

